<?php

# VERSION=1
# CHANGES="basic flash firmware GUI"

include_once("/usr/www/include/SQLite2ToSQLite3.php");
include('/usr/fallback/beroConf.php');
include('/usr/www/include/berogui_small.class.php');

$bc = new beroConf('root');

$gui = new berogui_small('beroNet SBC / VoIP Gateway: Firmware-Update');

echo	$gui->header(($_POST['action'] == 'install') ? 0 : 1) .
	'<div style="text-align: center;">' . "\n";


if (isset($_POST['Reset'])) {
	ob_start();
	?>
	<h1> Resetting Firmware </h1><br>
	Resetting Firmware not implented! <br>
	<?php
	echo ob_get_clean();
}
else if (isset($_POST['Flash']) || (isset($_POST['FlashURL']) && isset($_POST['flash_url']) &&  strlen ($_POST['flash_url']))) {

	ob_start();
	?>
	<h1> Flashing Firmware! </h1><br>
	<?php
	
	echo ob_get_clean();
	
	$ddflash = "/usr/www/cgi-bin/ddflash.sh";
	
	if (isset($_POST['Flash'])) {
		$url = $_POST['Flash'];
	}
	else {
		$url = $_POST['flash_url'];
	}
	$cmd = $ddflash . " " . $url;

	sleep (1);
	$result_code = 999;
	system ($cmd, $result_code);
	
	
	if ( $result_code == 0) {
		echo "<br><h1>------------------------------------------------------------</h1><br>";
		
	}
	else {
		echo "<br><h1><font color='red'>Flashing Failed!</font></h1><br>";
	}
}
else {

//only fetch it once
if ( !file_exists ("/tmp/flashimage.list")) {
	$result_code = 999;
	system ("wget http://www.beronet.com/wp-content/uploads/downloads/berofix/flashimage.list -O /tmp/flashimage.list &> /dev/null", $result_code);
	if ($result_code != 0) {
		echo "<br>";
		echo "<h3><font color='red'>Failed to fetch the image list</font></h3>";
// 		system ("rm -f /tmp/flashimage.list");
	}
}

//parse file
$image_versions = array ();
$image_urls = array ();

$image_count = 0;
if ( file_exists ("/tmp/flashimage.list")) {
	$lines = file('/tmp/flashimage.list');
	$count = 0;
	foreach($lines as $line) {
		$values=explode (" ", $line);
		$sz = sizeof ($values);
		if ($sz == 3) {
			if ($values[0] == "MTDIMAGES") {
				$image_versions[$image_count] = str_replace("\n", '', $values[1]);
				$image_urls[$image_count] = str_replace("\n", '',$values[2]);
				$image_count++;
			}
		}
	}
}

ob_start();
?>
<?php
if ($image_count) {
?>
	<h2> Firmware Flash </h2><br>
	<form name='flash' id='flash' action='/cgi-bin/flash-tool.php' method='POST'>
	
<?php
	for ($i = 0; $i < $image_count; $i++) {
		echo "\t\t<div>\n";
		echo "\t\t\t<button type='submit' id='Flash' name='Flash' value='" . $image_urls[$i] . "' onclick='javascript:return confirm(\"\\tThis will start flashing the Firmware.\\n\\n\\tThe process must not be interrupted!\\n\\n\\tAre you sure?\\n\\n\")'>\n";
		echo "\t\t\t\t" . $image_versions[$i] . "\n";
		echo "\t\t\t</button>\n";
		echo "\t\t</div>\n";
		if ($i +1 != $image_count) {
			echo "\t\t<br><br><br>\n";
		}
	}
?>
		
	</form>
	
	<br><br><br>
<?php
}
?>
	<h2> Flash Firmware from custom URL</h2><br>
	<form action="/cgi-bin/flash-tool.php" method="POST">
	<input type="hidden" name="action" value="download" />
	<input type="input" name="flash_url" style="font-size: 10px; font-family: monospace; width: 400px; margin-bottom: 5px;" /><br>
	<div><button type='submit' id='FlashURL' name='FlashURL' value='FlashURL'>Flash URL</button></div>
	</form><br>
	<?php
	echo ob_get_clean();
}


echo	'</div>' . "\n" .
	$gui->footer('flash-tool');

if (file_exists('/tmp/reboot_after_update')) {
            exec('/sbin/reboot');
}

?>
